#include<bits/stdc++.h>
using namespace std;
long long int A[75001];
int T;
long long int NZD(long long int a, long long int b)
{
    long long int tmp;
    while(b!=0)
    {
        tmp=a;
        a=b;
        b=tmp%b;
    }
    return a;
}
main()
{
    int j,ind=1;
    long long int n,m,i,x,t;
    scanf("%d",&T);
    for(j=0;j<T;j++)
    {
        scanf("%lld%lld",&n,&m);
        scanf("%lld%lld",&A[0],&A[1]);
        x=(int)abs(A[1]-A[0]);
        for(i=2;i<n;i++)
        {
            scanf("%lld",&A[i]);
            x=NZD(x,(int)abs(A[i]-A[i-1]));
        }
        for(i=0;i<m;i++)
        {
            scanf("%lld",&t);
            if(ind!=0)
            if((int)abs(t-A[0])%x==0)
                ind=0;

        }
        printf("%d\n",ind);
        ind=1;
    }
}